#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include "../include/arrayHelper.h"
#include "../include/fileReader.h"
#include "../include/server.h"

#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <unistd.h>

#define PORT 3090
#define BUFFER_SIZE 1024

int main(int argc, char *argv[]) {
    char *file = NULL;
    file = ReadHTML("/home/skingging/Documents/Projects/C/C-Webserver/HTML/index.html");
    
    char buffer[BUFFER_SIZE];
    char resp[] = "HTTP/1.0 200 OK\r\n"
                  "Server: webserver-c\r\n"
                  "Content-type: text/html\r\n\r\n"
                  "<html>hello, world</html>\r\n";
    
    char *temp = mergeArray(resp, file);
    
    // Create a socket
    int sockfd = socket(AF_INET, SOCK_STREAM, 0);
    
    if (sockfd == -1) {
        perror("webserver (socket)");
        return 1;
    }
    
    printf("socket created successfully\n");

    // Create the address to bind the socket to
    struct sockaddr_in host_addr;
    int host_addrlen = sizeof(host_addr);

    host_addr.sin_family = AF_INET;
    host_addr.sin_port = htons(PORT);
    host_addr.sin_addr.s_addr = htonl(INADDR_ANY);

    // Create client address
    struct sockaddr_in client_addr;
    int client_addrlen = sizeof(client_addr);

    // Bind the socket to the address
    if (bind(sockfd, (struct sockaddr *)&host_addr, host_addrlen) != 0) {
        perror("webserver (bind)");
        return 1;
    }
    
    printf("socket successfully bound to address\n");

    // Listen for incoming connections
    if (listen(sockfd, SOMAXCONN) != 0) {
        perror("webserver (listen)");
        return 1;
    }
    
    printf("server listening for connections\n");
    
    struct setup s;
    
    s.client_addr = client_addr;
    s.client_addrlen = client_addrlen;
    s.host_addr = host_addr;
    s.host_addrlen = host_addrlen;
    s.response = resp;
    s.sockfd = sockfd;
    
    serve(s);
    
    return 0;
}